/* ++++++++++
	$Source: /net/bally/be/rcs/src/addons/app_server/cirrus/cirrus.c,v $
	$Revision: 1.12 $
	$Author: pierre $
	$Date: 1996/04/08 19:24:17 $
	Copyright (c) 1995 by Be Incorporated.  All Rights Reserved.
+++++ */

#include <OS.h>
#include "kernel.h"
#include <vga.h>
#ifndef _CIRRUS_H
#include "cirrus.h"
#endif

/* -----
	handly definitions
----- */

#define  xprintf dprintf

/* -----
	private globals
----- */

static int              theVGA = 0;     /* ID of video chip */
static int              theMem = 0;     /* available memory in KB */
static int              scrnRowByte;
static int		        scrnWidth;
static int		        scrnHeight;
static int		        scrnColors = 8;
static void	            *scrnBase;
static float            scrnRate = 60.0;
static short            crtPosH = 50;
static short            crtSizeH = 50;
static short            crtPosV = 50;
static short            crtSizeV = 50;
static ulong            scrnResCode = 0xFFFFFFFFL;
static int              scrnResNum;
static uchar            *scrnBufBase;
static long		        scrnRes = vga640x480;
static short            lastCrtHT,lastCrtVT;
static long             hotpt_h = -1000;
static long             hotpt_v = -1000;
static ulong            available_spaces;

static volatile uchar   *isa_IO;

#define ISA_ADDRESS(x)  (isa_IO+(x))

static ulong            vga_res_available[2] =
{
  // 5434
	B_8_BIT_640x480|B_8_BIT_800x600|B_8_BIT_1024x768|
	B_32_BIT_640x480|B_32_BIT_800x600,
  // 543-
	B_8_BIT_640x480|B_8_BIT_800x600|B_8_BIT_1024x768,

};
//----------------------------------------------------------
// global tables (for all depth)
//----------------------------------------------------------

static ushort	sequencer_table[] =
{
	0x3c4,	0x00,	0x3c5,	0x03,	//Reset
	0x3c4,	0x01,	0x3c5,	0x03,	//Clocking mode
	0x3c4,	0x02,	0x3c5,	0x0f,	//Enable write plane
	0x3c4,	0x03,	0x3c5,	0x00,	//Char Font Select

	0x3c4,	0x04,	0x3c5,	0x0e,	//Memory Mode
	0x000,	0x00
};

//----------------------------------------

static ushort	attribute_table[] =
{
	0x00,	0x00,
	0x01,	0x01,
	0x02,	0x02,
	0x03,	0x03,
	0x04,	0x04,
	0x05,	0x05,
	0x06,	0x14,
	0x07,	0x07,
	0x08,	0x38,
	0x09,	0x39,
	0x0a,	0x3a,
	0x0b,	0x3b,
	0x0c,	0x3c,
	0x0d,	0x3d,
	0x0e,	0x3e,
	0x0f,	0x3f,
	0x10,	0x41,
	0x11,	0x00,
	0x12,	0x0f,
	0x13,	0x00,
	0x14,	0x00,
	0xff,	0xff
};

//----------------------------------------

static ushort	gcr_table[] =

{	0x3ce,	0x00,	0x3cf,	0x00,	//Set/Reset
	0x3ce,	0x01,	0x3cf,	0x00,	//Enable Set/Reset
	0x3ce,	0x02,	0x3cf,	0x00,	//Color Compare
	0x3ce,	0x03,	0x3cf,	0x00,	//Raster Operations/Rotate Counter
	0x3ce,	0x04,	0x3cf,	0x00,	//Read Plane Select
	0x3ce,	0x05,	0x3cf,	0x40,	//Graphics Controller
	0x3ce,	0x06,	0x3cf,	0x05,	//Memory Map Mode
	0x3ce,	0x07,	0x3cf,	0x0f,	//Color Don't care
	0x3ce,	0x08,	0x3cf,	0xff,	//Bit Mask
	0x000,	0x00 };

//----------------------------------------

static ushort	std_cirrus_vga_table[] =
{
	0x3c4,	0x00,	0x3c5,	0x01,	//Reset (not needed)
	0x3c2,	0x2f,	//Miscellaneous output
	0x3da,	0x00,	//Feature Control
	0x000,	0x00
};

//----------------------------------------

static ushort	vga_cirrus_table[] =

{
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3ce,	0x05,	0x3cf,	0x40,	// 256 colors
	0x3ce,	0x06,	0x3cf,	0x01,	// graphic mode (not text)
	0x3ce,	0x08,	0x3cf,	0xff,	// write mask disabled
	0x3c0,	0x10,	0x3c0,	0x01,	// graphic mode (not text)
	0x3c4,	0x07,	0x3c5,	0x11,	// linear adressing and high resolution select
	0x3c4,	0x08,	0x3c5,	0x00,	// EEPROM control
	0x3c4,	0x0f,	0x3c5,	0x30,	// 8bit extended video mode
	0x3c4,	0x10,	0x3c5,	0x00,	// graphic cursor X position
	0x3c4,	0x11,	0x3c5,	0x00,	// graphic cursor Y position
	0x3c4,	0x12,	0x3c5,	0x00,	// graphic cursor control (disabled)
	0x3c4,	0x13,	0x3c5,	0x00,	// graphic cursor index selection
//	0x3c4,	0x17,	0x3c5,	0x22,	// DAC wriet shadowing disabled
	0x3c4,	0x18,	0x3c5,	0x00,	// Signature generator disabled
	0x3ce,	0x09,	0x3cf,	0x00,	// offset register 0
	0x3ce,	0x0a,	0x3cf,	0x00,	// offset regsiter 1
	0x3ce,	0x0b,	0x3cf,	0x20,	// extended write mode disabled (00)
	0x3ce,	0x0e,	0x3cf,	0x00,	// DCLK output divide by 2 off
	0x3ce,	0x30,	0x3cf,	0x00,	// BitBLT mode
	0x000,	0x00			// End-of-table
};

//----------------------------------------

static ushort	vga_cirrus_table32[] =

{
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3ce,	0x05,	0x3cf,	0x40,	// 256 colors
	0x3ce,	0x06,	0x3cf,	0x01,	// graphic mode (not text)
	0x3ce,	0x08,	0x3cf,	0xff,	// write mask disabled
	0x3c0,	0x10,	0x3c0,	0x01,	// graphic mode (not text)
	0x3c4,	0x07,	0x3c5,	0x19,	// linear adressing and high resolution select
	0x3c4,	0x08,	0x3c5,	0x00,	// EEPROM control
	0x3c4,	0x0f,	0x3c5,	0x38,	// 32bit extended video mode
	0x3c4,	0x10,	0x3c5,	0x00,	// graphic cursor X position
	0x3c4,	0x11,	0x3c5,	0x00,	// graphic cursor Y position
	0x3c4,	0x12,	0x3c5,	0x00,	// graphic cursor control (disabled)
	0x3c4,	0x13,	0x3c5,	0x00,	// graphic cursor index selection
//	0x3c4,	0x17,	0x3c5,	0x22,	// DAC write shadowing disabled
	0x3c4,	0x18,	0x3c5,	0x00,	// Signature generator disabled
	0x3ce,	0x09,	0x3cf,	0x00,	// offset register 0
	0x3ce,	0x0a,	0x3cf,	0x00,	// offset regsiter 1
	0x3ce,	0x0b,	0x3cf,	0x20,	// extended write mode disabled (00)
	0x3ce,	0x0e,	0x3cf,	0x00,	// DCLK output divide by 2 off
	0x3ce,	0x30,	0x3cf,	0x00,	// BitBLT mode
	0x000,	0x00			// End-of-table
};

//----------------------------------------

static ushort	crt_cirrus_640x480_table[] =

{
	0x3c4,	0x06,	0x3c5,	0x0F,	// lock registers	
	0x3c2,	0x03,					// clock 0, color, cpu access to videoram ok
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3d4,	0x17,	0x3d5,	0x2b,	// CRTC Mode Control
// clock settings
	0x3c4,	0x1f,	0x3c5,	0xa2,	// memory clock = 60.8 Mhz

	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x0e,	0x3d5,	0x00,	// Cursor Location Address High
	0x3d4,	0x0f,	0x3d5,	0x00,	// Cursor Location Address Low
	0x3d4,	0x13,	0x3d5,	0x50,	// Offset
	0x3d4,	0x14,	0x3d5,	0x60,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xab,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare
	0x3d4,	0x19,	0x3d5,	0x31,	// CRT extended control
	0x3d4,	0x1a,	0x3d5,	0x00,	// CRT extended control
	0x3d4,	0x1b,	0x3d5,	0x02,	// enhanced memory wrapping

	0x00,	0x00			// End-of-table
};

static ushort   crt_cirrus_640x480_map[] =
{
	0x10,                           // or mask for 0x07
	0x40,                           // or mask for 0x09
	0x00,                           // or mask for 0x11
	108,  80,  80, 106,  96, 106,   // left narrow settings
	108,  80,  80, 106,  82,  92,   // right narrow settings
	 94,  80,  80,  92,  85,  93,   // left wide settings
	 94,  80,  80,  92,  81,  89,   // right wide settings
//	100,  80,  80,  98,  84,  96,   // center
	525, 518, 520, 480, 488, 517,   // top short settings
	525, 482, 484, 480, 488, 517,   // bottom short settings
	525, 518, 520, 480, 488, 517,   // top tall settings
	525, 482, 484, 480, 488, 517,   // bottom tall settings
//	525, 490, 492, 480, 488, 516,   // center
};

//----------------------------------------

static ushort	crt_cirrus_800x600_table[] =

{
	0x3c4,	0x06,	0x3c5,	0x0F,	// lock registers	
	0x3c2,	0x03,					// clock 0, color, cpu access to videoram ok
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3d4,	0x17,	0x3d5,	0x2b,	// CRTC Mode Control
// clock settings
	0x3c4,	0x1f,	0x3c5,	0xa2,	// memory clock = 60.8 Mhz

	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x0e,	0x3d5,	0xff,	// Cursor Location Address High
	0x3d4,	0x0f,	0x3d5,	0x00,	// Cursor Location Address Low
	0x3d4,	0x13,	0x3d5,	0x64,	// Offset
	0x3d4,	0x14,	0x3d5,	0x00,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xe3,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare
	0x3d4,	0x19,	0x3d5,	0x46,	// CRT extended control
	0x3d4,	0x1a,	0x3d5,	0x00,	// CRT extended control
	0x3d4,	0x1b,	0x3d5,	0x02,	// enhanced memory wrapping
	0x00,	0x00			// End-of-table
};

static ushort   crt_cirrus_800x600_map[] =
{
	0x10,                           // or mask for 0x07
	0x40,                           // or mask for 0x09
	0x00,                           // or mask for 0x11
	140, 100, 102, 138, 122, 134,   // left narrow settings
	140, 100, 102, 138, 102, 114,   // right narrow settings
	120, 100, 102, 118, 107, 117,   // left wide settings
	120, 100, 102, 118, 101, 111,   // right wide settings
//	141, 100, 102, 138, 107, 117,   // right wide settings
    633, 627, 629, 600, 605, 628,   // top short settings
	633, 604, 606, 600, 605, 628,   // bottom short settings
	633, 627, 629, 600, 605, 628,   // top tall settings
	633, 604, 606, 600, 605, 628,   // bottom tall settings
//	633, 604, 606, 600, 605, 628,   // bottom tall settings
};

//----------------------------------------

static ushort	crt_cirrus_1024x768_table[] =
{
	0x3c4,	0x06,	0x3c5,	0x0F,	// lock registers	
	0x3c2,	0x03,					// clock 0, color, cpu access to videoram ok
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3d4,	0x17,	0x3d5,	0x2b,	// CRTC Mode Control
// clock settings
	0x3c4,	0x1f,	0x3c5,	0xa2,	// memory clock = 60.8 Mhz

	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x0e,	0x3d5,	0xff,	// Cursor Location Address High
	0x3d4,	0x0f,	0x3d5,	0x00,	// Cursor Location Address Low
	0x3d4,	0x13,	0x3d5,	0x80,	// Offset
	0x3d4,	0x14,	0x3d5,	0x00,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xe3,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare
	0x3d4,	0x19,	0x3d5,	0x46,	// CRT extended control
	0x3d4,	0x1a,	0x3d5,	0x00,	// CRT extended control
	0x3d4,	0x1b,	0x3d5,	0x02,	// enhanced memory wrapping
	0x00,	0x00			// End-of-table
};

static ushort   crt_cirrus_1024x768_map[] =
{
	0x10,                           // or mask for 0x07
	0x40,                           // or mask for 0x09
	0x00,                           // or mask for 0x11
	176, 128, 130, 174, 156, 170,   // left narrow settings
	176, 128, 130, 174, 130, 144,   // right narrow settings
	152, 128, 130, 150, 137, 148,   // left wide settings
	152, 128, 130, 150, 129, 140,   // right wide settings
//	161, 128, 130, 154, 136, 149,   // center
    850, 834, 844, 768, 774, 844,   // top short settings
	850, 772, 782, 768, 774, 844,   // bottom short settings
	850, 834, 844, 768, 774, 844,   // top tall settings
	850, 772, 782, 768, 774, 844,   // bottom tall settings
//	850, 772, 782, 768, 774, 844,   // center
};

//----------------------------------------

static ushort	crt_cirrus_640x480_table32[] =

{
	0x3c4,	0x06,	0x3c5,	0x0F,	// lock registers	
	0x3c2,	0x03,					// clock 0, color, cpu access to videoram ok
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3d4,	0x17,	0x3d5,	0x2b,	// CRTC Mode Control
// clock settings
	0x3c4,	0x1f,	0x3c5,	0x22,	// memory clock = 60.9 Mhz

	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x0e,	0x3d5,	0x00,	// Cursor Location Address High
	0x3d4,	0x0f,	0x3d5,	0x00,	// Cursor Location Address Low
	0x3d4,	0x13,	0x3d5,	0xa0,	// Offset
	0x3d4,	0x14,	0x3d5,	0x60,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xab,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare
	0x3d4,	0x19,	0x3d5,	0x31,	// CRT extended control
	0x3d4,	0x1a,	0x3d5,	0x00,	// CRT extended control
	0x3d4,	0x1b,	0x3d5,	0x02,	// enhanced memory wrapping

	0x00,	0x00			// End-of-table
};

static ushort   crt_cirrus_640x480_map32[] =
{
	0x10,                           // or mask for 0x07
	0x40,                           // or mask for 0x09
	0x00,                           // or mask for 0x11
	108,  80,  80, 106,  96, 106,   // left narrow settings
	108,  80,  80, 106,  82,  92,   // right narrow settings
	 94,  80,  80,  92,  85,  93,   // left wide settings
	 94,  80,  80,  92,  81,  89,   // right wide settings
//	100,  80,  80,  98,  84,  96,   // center
	525, 518, 520, 480, 488, 517,   // top short settings
	525, 482, 484, 480, 488, 517,   // bottom short settings
	525, 518, 520, 480, 488, 517,   // top tall settings
	525, 482, 484, 480, 488, 517,   // bottom tall settings
//	525, 490, 492, 480, 488, 516,   // center
};

//----------------------------------------

static ushort	crt_cirrus_800x600_table32[] =

{
	0x3c4,	0x06,	0x3c5,	0x0F,	// lock registers	
	0x3c2,	0x03,					// clock 0, color, cpu access to videoram ok
	0x3c4,	0x06,	0x3c5,	0x12,	// unlock registers	
	0x3d4,	0x17,	0x3d5,	0x2b,	// CRTC Mode Control
// clock settings
	0x3c4,	0x1f,	0x3c5,	0x22,	// memory clock = 60.9 Mhz

	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x0e,	0x3d5,	0xff,	// Cursor Location Address High
	0x3d4,	0x0f,	0x3d5,	0x00,	// Cursor Location Address Low
	0x3d4,	0x13,	0x3d5,	0xC8,	// Offset
	0x3d4,	0x14,	0x3d5,	0x00,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xe3,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare
	0x3d4,	0x19,	0x3d5,	0x46,	// CRT extended control
	0x3d4,	0x1a,	0x3d5,	0x00,	// CRT extended control
	0x3d4,	0x1b,	0x3d5,	0x02,	// enhanced memory wrapping
	0x00,	0x00			// End-of-table
};

static ushort   crt_cirrus_800x600_map32[] =
{
	0x10,                           // or mask for 0x07
	0x40,                           // or mask for 0x09
	0x00,                           // or mask for 0x11
	140, 100, 102, 138, 122, 134,   // left narrow settings
	140, 100, 102, 138, 102, 114,   // right narrow settings
	120, 100, 102, 118, 107, 117,   // left wide settings
	120, 100, 102, 118, 101, 111,   // right wide settings
//	141, 100, 102, 138, 107, 117,   // right wide settings
    633, 627, 629, 600, 605, 628,   // top short settings
	633, 604, 606, 600, 605, 628,   // bottom short settings
	633, 627, 629, 600, 605, 628,   // top tall settings
	633, 604, 606, 600, 605, 628,   // bottom tall settings
//	633, 604, 606, 600, 605, 628,   // bottom tall settings
};

//----------------------------------------------------------
// rates limit availables.
//----------------------------------------------------------

static float vga_min_rates[32] = {
	56.0, 56.0, 56.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	56.0, 56.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 
};

static float vga_max_rates[32] = {
	90.0, 75.0, 72.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	90.0, 75.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0, 60.0, 60.0, 60.0,
	60.0, 60.0,
};

//----------------------------------------------------------
// accelerated specific stuff dispatcher
//----------------------------------------------------------

/* prototypes for dispatch table */
long    set_cursor_shape(uchar *data,uchar *mask,long dim_h,long dim_v,long hot_h,long hot_v);
long    move_cursor(long new_h,long new_v);
long    show_cursor(bool state);
long 	rect_8(long x1, long y1, long x2, long y2,uchar color);
long 	rect_32(long x1, long y1, long x2, long y2,ulong color);
long 	blit(long x1, long y1, long x2, long y2, long width, long height);


/* dispatch table */
static graphics_card_hook vga_dispatch[B_HOOK_COUNT] = {
// 0
	(graphics_card_hook)set_cursor_shape,
	(graphics_card_hook)move_cursor,
	(graphics_card_hook)show_cursor,
	0L,
	0L,
// 5
	(graphics_card_hook)rect_8,
	(graphics_card_hook)rect_32,
	(graphics_card_hook)blit,
	0L,
	0L,
// 10
	0L,
	0L,
	0L,
	0L,
	0L,
// 15
	0L,
	0L,
	0L,
	0L,
	0L,
// 20
	0L,
	0L,
	0L,
	0L,
	0L,
// 25
	0L,
	0L,
	0L,
	0L,
	0L,
// 30
	0L,
	0L,
	0L,
	0L,
	0L,
// 35
	0L,
	0L,
	0L,
	0L,
	0L,
// 40
	0L,
	0L,
	0L,
	0L,
	0L,
// 45
	0L,
	0L,
	0L,
};

//------------------------------------------------------
// standard input/output stuff
//------------------------------------------------------

static void	outp(long address, uchar value)
{
	*(vuchar *)ISA_ADDRESS(address) = value;
}

//----------------------------------------

static void	outpw(long address, ushort value)
{
	ushort	tmp;

	tmp = ((value & 0xff) << 8) | ((value >> 8) & 0xff);
	*(vushort *)ISA_ADDRESS(address) = tmp;
}

//----------------------------------------

static void	outpl(long address, ulong value)
{
	*(vulong *)ISA_ADDRESS(address) = value;
}

//----------------------------------------

static uchar	inp(long address)
{
	return(*(vuchar *)ISA_ADDRESS(address));
}

//----------------------------------------

static ushort	inpw(long address)
{
	ushort	value;

	value = *(vushort *)ISA_ADDRESS (address);
	return(((value & 0xff) << 8) | ((value >> 8) & 0xff));
}

//----------------------------------------------------------
// card io access protection
//----------------------------------------------------------

static sem_id	io_sem = -1;
static sem_id   ge_sem = -1;
static long	    io_lock,ge_lock;

void init_locks()
{
	io_lock = 0L;
	io_sem = create_sem(0,"vga io sem");
	ge_lock = 0L;
	ge_sem = create_sem(0,"vga ge sem");
}

void dispose_locks()
{
	if (ge_sem >= 0) {
		delete_sem(ge_sem);
		delete_sem(io_sem);
	}
}

void lock_io()
{
	int	old;

	old = atomic_add (&io_lock, 1);
	if (old >= 1) {
		acquire_sem(io_sem);	
	}	
}

void unlock_io()
{
	int	old;

	old = atomic_add (&io_lock, -1);
	if (old > 1) {
		release_sem(io_sem);
	}
}	

void lock_ge()
{
	int	old;

	old = atomic_add (&ge_lock, 1);
	if (old >= 1) {
		acquire_sem(ge_sem);	
	}	
}

void unlock_ge()
{
	int	old;

	old = atomic_add (&ge_lock, -1);
	if (old > 1) {
		release_sem(ge_sem);
	}
}	

//----------------------------------------------------------
// accelerated specific stuff
//----------------------------------------------------------

long set_cursor_shape(uchar *data,uchar *mask,long dim_h,long dim_v,long hot_h,long hot_v)
{
	uchar   *buf;
	uchar   prev;
	int     i,j,dim_h0;
	int     init;

	lock_io();
	if (hotpt_h == -1000)
		init = 1;
	else
		init = 0;
	hotpt_h = hot_h;
	hotpt_v = hot_v;
	dim_h0 = dim_h>>3;
	buf = (uchar*)scrnBase+1024*theMem-256;

	for (i=0;i<256;i++)
		buf[i] = 0x00;
	
	for (i=0;i<dim_v;i++)
		for (j=0;j<dim_h0;j++) {
			buf[0+i*4+j] = data[j+i*dim_h0];
			buf[128+i*4+j] = mask[j+i*dim_h0]^0xff;
		}

	/* set cursor data pointer */
	outp(0x3c4,0x12);
	prev = inp(0x3c5)&1;
	outp(0x3c5,0x02|prev);
	
	outp(0x3c8,0x0f);
	outp(0x3c9,0x00);
	outp(0x3c9,0x00);
	outp(0x3c9,0x00);
			
	outp(0x3c8,0x00);
	outp(0x3c9,0xff);
	outp(0x3c9,0xff);
	outp(0x3c9,0xff);

	if (init) {
		outp(0x3c4,0x10);
		outp(0x3c5,0);
		outp(0x3c4,0x11);
		outp(0x3c5,0);
		outp(0x3c4,0x12);
		outp(0x3c5,0x00);
	}
	outp(0x3c4,0x13);
	outp(0x3c5,0x3f);
	outp(0x3c4,0x12);
	outp(0x3c5,prev);
	unlock_io();
	
	return B_NO_ERROR;
}

long move_cursor(long new_h,long new_v)
{
	long h,v;

	lock_io();
	h = new_h-hotpt_h;
	v = new_v-hotpt_v;
	if (h < 0) h = 0;
	if (v < 0) v = 0;

	outp(0x3c4,0x10+((h<<5)&0xe0));
	outp(0x3c5,(h>>3)&255);
	outp(0x3c4,0x11+((v<<5)&0xe0));
	outp(0x3c5,(v>>3)&255);
	unlock_io();
	
	return B_NO_ERROR;
}

long show_cursor(bool state)
{
	lock_io();
	if (state == 0) {
		outp(0x3c4,0x12);
		outp(0x3c5,0x00);
	}
	else {
		outp(0x3c4,0x12);
		outp(0x3c5,0x01);
	}
	unlock_io();
	return B_NO_ERROR;
}

long rect_8(long x1, long y1, long x2, long y2, uchar color)
{
	long     y,adr1,height,width;
	char     oper;

	lock_ge();
	outp(0x3ce,0x31);
	outp(0x3cf,4);
	
	adr1 = y1*scrnRowByte+x1;
	height = y2-y1;
	width = x2-x1;
	
	outp(0x3ce,0x00);
	outp(0x3cf,color);

	outp(0x3ce,0x01);
	outp(0x3cf,color);

	outp(0x3ce,0x20);
	outp(0x3cf,width&255);
	outp(0x3ce,0x21);
	outp(0x3cf,(width>>8)&255);

	outp(0x3ce,0x22);
	outp(0x3cf,height&255);
	outp(0x3ce,0x23);
	outp(0x3cf,(height>>8)&255);

	outp(0x3ce,0x24);
	outp(0x3cf,scrnRowByte&255);
	outp(0x3ce,0x25);
	outp(0x3cf,(scrnRowByte>>8)&255);

	outp(0x3ce,0x26);
	outp(0x3cf,0);
	outp(0x3ce,0x27);
	outp(0x3cf,0);

	outp(0x3ce,0x28);
	outp(0x3cf,adr1&255);
	outp(0x3ce,0x29);
	outp(0x3cf,(adr1>>8)&255);
	outp(0x3ce,0x2a);
	outp(0x3cf,(adr1>>16)&255);

	outp(0x3ce,0x2c);
	outp(0x3cf,(long)scrnBase&255);
	outp(0x3ce,0x2d);
	outp(0x3cf,((long)scrnBase>>8)&255);
	outp(0x3ce,0x2e);
	outp(0x3cf,((long)scrnBase>>16)&255);
	
	outp(0x3ce,0x2f);
	outp(0x3cf,0);
	
	outp(0x3ce,0x30);
	outp(0x3cf,0x80);

	outp(0x3ce,0x32);
	outp(0x3cf,0x0d);

	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	
	outp(0x3ce,0x31);
	outp(0x3cf,2);
	
	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	unlock_ge();
	
	return B_NO_ERROR;
}

long rect_32(long x1, long y1, long x2, long y2, ulong color)
{
	long     y,adr1,height,width;
	char     oper;

	lock_ge();
	outp(0x3ce,0x31);
	outp(0x3cf,4);
	
	x1 <<= 2;
	x2 = (x2<<2)+3;
	
	adr1 = y1*scrnRowByte+x1;
	height = y2-y1;
	width = x2-x1;
	
	outp(0x3ce,0x00);
	outp(0x3cf,(color>>24)&255);
	outp(0x3ce,0x01);
	outp(0x3cf,(color>>24)&255);
	outp(0x3ce,0x10);
	outp(0x3cf,(color>>16)&255);
	outp(0x3ce,0x11);
	outp(0x3cf,(color>>16)&255);
	outp(0x3ce,0x12);
	outp(0x3cf,(color>>8)&255);
	outp(0x3ce,0x13);
	outp(0x3cf,(color>>8)&255);
	outp(0x3ce,0x14);
	outp(0x3cf,(color>>0)&255);
	outp(0x3ce,0x15);
	outp(0x3cf,(color>>0)&255);

	outp(0x3ce,0x20);
	outp(0x3cf,width&255);
	outp(0x3ce,0x21);
	outp(0x3cf,(width>>8)&255);

	outp(0x3ce,0x22);
	outp(0x3cf,height&255);
	outp(0x3ce,0x23);
	outp(0x3cf,(height>>8)&255);

	outp(0x3ce,0x24);
	outp(0x3cf,scrnRowByte&255);
	outp(0x3ce,0x25);
	outp(0x3cf,(scrnRowByte>>8)&255);

	outp(0x3ce,0x26);
	outp(0x3cf,0);
	outp(0x3ce,0x27);
	outp(0x3cf,0);

	outp(0x3ce,0x28);
	outp(0x3cf,adr1&255);
	outp(0x3ce,0x29);
	outp(0x3cf,(adr1>>8)&255);
	outp(0x3ce,0x2a);
	outp(0x3cf,(adr1>>16)&255);

	outp(0x3ce,0x2c);
	outp(0x3cf,(long)scrnBase&255);
	outp(0x3ce,0x2d);
	outp(0x3cf,((long)scrnBase>>8)&255);
	outp(0x3ce,0x2e);
	outp(0x3cf,((long)scrnBase>>16)&255);
	
	outp(0x3ce,0x2f);
	outp(0x3cf,0);
	
	outp(0x3ce,0x30);
	outp(0x3cf,0xb0);

	outp(0x3ce,0x32);
	outp(0x3cf,0x0d);

	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	
	outp(0x3ce,0x31);
	outp(0x3cf,2);
	
	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	unlock_ge();
	
	return B_NO_ERROR;
}

long blit(long x1, long y1, long x2, long y2, long width, long height)
{
	long     adr1,adr2;
	char     mode;

	lock_ge();
	outp(0x3ce,0x31);
	outp(0x3cf,4);

	if (scrnColors == 32) {
		x1 <<= 2;
		x2 <<= 2;
		width = (width<<2)+3;
	}
	
	adr1 = y1*scrnRowByte+x1;
	adr2 = y2*scrnRowByte+x2;
	if (adr1 < adr2){
		mode = 1;
		adr1 += scrnRowByte*height+width;
		adr2 += scrnRowByte*height+width;
	}
	else mode = 0;
	
	outp(0x3ce,0x20);
	outp(0x3cf,width&255);
	outp(0x3ce,0x21);
	outp(0x3cf,(width>>8)&255);

	outp(0x3ce,0x22);
	outp(0x3cf,height&255);
	outp(0x3ce,0x23);
	outp(0x3cf,(height>>8)&255);

	outp(0x3ce,0x24);
	outp(0x3cf,scrnRowByte&255);
	outp(0x3ce,0x25);
	outp(0x3cf,(scrnRowByte>>8)&255);

	outp(0x3ce,0x26);
	outp(0x3cf,scrnRowByte&255);
	outp(0x3ce,0x27);
	outp(0x3cf,(scrnRowByte>>8)&255);

	outp(0x3ce,0x28);
	outp(0x3cf,adr2&255);
	outp(0x3ce,0x29);
	outp(0x3cf,(adr2>>8)&255);
	outp(0x3ce,0x2a);
	outp(0x3cf,(adr2>>16)&255);
	
	outp(0x3ce,0x2c);
	outp(0x3cf,adr1&255);
	outp(0x3ce,0x2d);
	outp(0x3cf,(adr1>>8)&255);
	outp(0x3ce,0x2e);
	outp(0x3cf,(adr1>>16)&255);

	outp(0x3ce,0x2f);
	outp(0x3cf,0);
	
	outp(0x3ce,0x30);
	outp(0x3cf,mode);

	outp(0x3ce,0x32);
	outp(0x3cf,0x0d);

	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	
	outp(0x3ce,0x31);
	outp(0x3cf,2);
	
	outp(0x3ce,0x31);
	while ((inp(0x3cf) & 8) == 8) {};
	unlock_ge();
	
	return B_NO_ERROR;
}

//--------------------------------------------------------------
// Global In/Out routines
//--------------------------------------------------------------

static void	setup_dac()
{
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	outp(0x3c6, 0x00);
	inp(0x3c8);
	outp(0x3c6, 0xff);
}

//----------------------------------------

static void	setup_dac32()
{
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	outp(0x3c6, 0xc5);
	inp(0x3c8);
	outp(0x3c6, 0xff);
}

//----------------------------------------

static void	set_attr_table(ushort *ptr)
{
	ushort	p1;
	ushort	p2;
	uchar	v;
	
	inp(0x3da);
	v = inp(0x3c0);

	while(1) {
		p1 = *ptr++;
		p2 = *ptr++;
		if (p1 == 0xff && p2 == 0xff) {
			inp(0x3da);
			outp(0x3c0, v | 0x20);
			return;
		}
		inp(0x3da);
		outp(0x3c0, p1);
		outp(0x3c0, p2);
	}
}

//----------------------------------------

static void	set_table(ushort *ptr)
{
	ushort	p1;
	ushort	p2;

	while(1) {
		p1 = *ptr++;
		p2 = *ptr++;
		if (p1 == 0 && p2 == 0) {
			return;
		}
		outp(p1, p2);
	}
}

//----------------------------------------

static float ScreenClockStep[32] =
{
	8.0, 8.0, 8.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0, 0.0,
	8.0, 8.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0, 0.0,
	0.0, 0.0,
};

void select_clock()
{
	float    freq,fr,fr0,fr2;
	int      p,q,p2,q2;

	freq = ScreenClockStep[scrnResNum] * scrnRate *
		   (float)lastCrtHT * (float)lastCrtVT * 1e-6;

// calcul p and q parameters (method 1)
	fr0 = freq/TI_REF_FREQ;
	fr2 = -2.0;
	for (q=1;q<=31;q++) {
		p = (int)(fr0*((float)q)+0.5);
		fr = ((float)p)/((float)q);
		if (((fr0-fr)*(fr0-fr) < (fr0-fr2)*(fr0-fr2)) && (p>1) && (p<128)) {
			p2 = p;
			q2 = 2*q+0;
			fr2 = fr;
		}
	}

// calcul p and q parameters (method 2)
	fr0 = freq/(TI_REF_FREQ/2);
	for (q=1;q<=63;q++) {
		p = (int)(fr0*((float)q)+0.5);
		fr = ((float)p)/((float)q);
		if (((fr0-fr)*(fr0-fr) < (fr0-fr2)*(fr0-fr2)) && (p>1) && (p<128)) {
			p2 = p;
			q2 = 2*q+1;
			fr2 = fr;
		}
	}

	outp(0x3c4,0x06);
	outp(0x3c5,0x12);
	outp(0x3c4,0x0b);
	outp(0x3c5,p2);
	outp(0x3c4,0x1b);
	outp(0x3c5,q2);
}

//----------------------------------------

static void	cirrus_init()
{
	int		i;
	struct x {
			int	offset;
			int	value;
			int size;
	} init_tab[] = {
			{0x46e8, 0x1600, 2},	/* go into setup mode */
			{ 0x102,   0x01, 1},	/* disable sleep mode (WAKE UP, DAMMIT) */
			{0x46e8,   0x0e, 1},	/* go out setup mode */
			{ 0x3C4,   0x06, 1},	/* enhanced function control */
			{ 0x3C5,   0x0F, 1},	/* enhanced function control */
			{ 0x3c2,   0x0b, 1},	/* clock 2, color, cpu access to videoram ok */
			{ 0x3C4,   0x06, 1},	/* enhanced function control */
			{ 0x3C5,   0x12, 1},	/* enhanced function enabled */
	};
	struct x *p;

	for (i = 0; i < sizeof (init_tab) / sizeof (struct x); i++) {
		p = init_tab + i;
		switch (p->size) {
		case 1:
			*(unsigned char *)ISA_ADDRESS(p->offset) = p->value;
			break;
		case 2:
			*(unsigned short *)ISA_ADDRESS(p->offset) = p->value;
			break;
		case 4:
			*(unsigned long*)ISA_ADDRESS(p->offset) = p->value;
			break;
		default:
			break;
		}
	}
}

/* ----------
	vid_checkmem : check size of the available memory
----- */

static int vid_checkmem (void)
{
	bool      test;
	long      i,j;
	double    time;
	
	cirrus_init();
	set_table(std_cirrus_vga_table);
	set_table(vga_cirrus_table32);
	set_table(sequencer_table);
	set_attr_table(attribute_table);
		
// Write 32 bytes pattern every 256K
	for (i=0;i<8;i++)
		for (j=0;j<32;j++)
			((uchar*)scrnBase)[(i<<18)+j] = (i<<5)+j;

// Check if the pattern are all the same (no wrapping).
	test = TRUE;
	for (i=0;i<8;i++)
		for (j=0;j<32;j++)
			if (((uchar*)scrnBase)[(i<<18)+j] != (i<<5)+j)
				test = FALSE;
	if (test)
		theMem = 2048;
	else
		theMem = 1024;

// Display available amount of memory	
	dprintf("Graphic memory available : %d Ko\n",theMem);

// Measure the writing bandwidth to the videocard on a 800K buffer, using 64
// bits writing access.
	time = system_time();
	for (j=0;j<2;j++)
		for (i=0;i<51200;i++)
			((double*)scrnBase)[i] = 0L;
	time = system_time()-time;

// Display available writing bandwidth
	dprintf("Memory card bandwidth : %d Kb/s\n",(long)(800000000.0/time));

// The spaces available depend of the amount of video memory available...	
	available_spaces = B_8_BIT_640x480 | B_8_BIT_800x600;
	if (theMem >= 1024)
		available_spaces |= B_8_BIT_1024x768;
	if (theMem >= 1536)
		available_spaces |= B_32_BIT_640x480;
	if (theMem >= 2048)
		available_spaces |= B_32_BIT_800x600;
	
// ...and the specific abilities of the add-on depending of the chip sets.
	available_spaces &= vga_res_available[theVGA];
}
			
/* ----------
	vid_select_crt : crt settings
----- */

static uchar crt_index[] =
{ 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x09, 0x10, 0x11, 0x12, 0x15, 0x16 };

static 	uchar     settings[14];

static void prepare_crt (ushort *set)
{
	int       i;
	ulong     p0,p1,p2,p3;
	ushort    Hset[6],Vset[6];
	
	p0 = (100-crtPosH)*(100-crtSizeH);
	p1 = (crtPosH)*(100-crtSizeH);
	p2 = (100-crtPosH)*(crtSizeH);
	p3 = (crtPosH)*(crtSizeH);
	for (i=0;i<6;i++)
		Hset[i] = (p0*(ulong)set[3+i]+
				   p1*(ulong)set[9+i]+
				   p2*(ulong)set[15+i]+
				   p3*(ulong)set[21+i]+5000)/10000;
	p0 = (100-crtPosV)*(100-crtSizeV);
	p1 = (crtPosV)*(100-crtSizeV);
	p2 = (100-crtPosV)*(crtSizeV);
	p3 = (crtPosV)*(crtSizeV);
	for (i=0;i<6;i++)
		Vset[i] = (p0*(ulong)set[27+i]+
				   p1*(ulong)set[33+i]+
				   p2*(ulong)set[39+i]+
				   p3*(ulong)set[45+i]+5000)/10000;

//	for (i=0;i<6;i++)
//		_kdprintf_("Hset[%d] = %d\n",i,Hset[i]);
//	for (i=0;i<6;i++)
//		_kdprintf_("Vset[%d] = %d\n",i,Vset[i]);

	lastCrtHT = Hset[0];
	lastCrtVT = Vset[0];

	Hset[0] -= 5;
	Hset[1] -= 1;
	Vset[0] -= 2;
	Vset[3] -= 1;
	Vset[4] -= 1;

	Vset[2] = (Vset[2]&15);
	Vset[5] = (Vset[5]&255);
	
	settings[0] = Hset[0]&255;
	settings[1] = Hset[1]&255;
	settings[2] = Hset[2]&255;
	settings[3] = Hset[3]&31 | 128;
	settings[4] = Hset[4]&255;
	settings[5] = Hset[5]&31 | ((Hset[3]&32)<<2);
	settings[6] = Vset[0]&255;
	settings[7] = ((Vset[0]&256)>>8) | ((Vset[3]&256)>>7) | ((Vset[1]&256)>>6) | set[0] |
		((Vset[4]&256)>>5) | ((Vset[0]&512)>>4) | ((Vset[3]&512)>>3) | ((Vset[1]&512)>>2);
	settings[8] = set[1] | ((Vset[4]&512)>>4);
	settings[9] = Vset[1]&255;
	settings[10] = Vset[2]&15 | set[2];
	settings[11] = Vset[3]&255;
	settings[12] = Vset[4]&255;
	settings[13] = Vset[5]&255;
}

static set_crt()
{
	int      i;
	
	for (i=0;i<14;i++) {
//		_kdprintf_("index = %x, %x\n",crt_index_864[i],settings[i]);
		outp(0x3d4, crt_index[i]);
		outp(0x3d5, settings[i]);
	}
}

static void vid_prepare_crt_8(void)
{
	if (scrnRes == vga640x480)
		prepare_crt(crt_cirrus_640x480_map);
	else if (scrnRes == vga800x600)
		prepare_crt(crt_cirrus_800x600_map);
	else 
		prepare_crt(crt_cirrus_1024x768_map);
}

static void vid_select_crt_8(void)
{
	if (scrnRes == vga640x480)
		set_table(crt_cirrus_640x480_table);
	else if (scrnRes == vga800x600)
		set_table(crt_cirrus_800x600_table);
	else
		set_table(crt_cirrus_1024x768_table);
	set_crt();
}

static void vid_prepare_crt_32(void)
{
	if (scrnRes == vga640x480)
		prepare_crt(crt_cirrus_640x480_map32);
	else
		prepare_crt(crt_cirrus_800x600_map32);
}

static void vid_select_crt_32(void)
{
	if (scrnRes == vga640x480)
		set_table(crt_cirrus_640x480_table32);
	else
		set_table(crt_cirrus_800x600_table32);
	set_crt();
}

/* ----------
	vid_selectrate : set current refresh rate
----- */

static int vid_selectrate (void)
{
	lock_io();
	lock_ge();

	outp(0x3c4, 0x01);
	outp(0x3c5, 0x21);		// blank the screen

	if (scrnColors == 8) {
		vid_prepare_crt_8();
		select_clock();
		vid_select_crt_8();
	} else {
		vid_prepare_crt_32();
		select_clock();
		vid_select_crt_32();
	}

	outp(0x3c4, 0x01);
	outp(0x3c5, 0x01);		// blank the screen

	unlock_ge();
	unlock_io();
}

/* ----------
	vid_selectmode : set current depth and resolution
----- */

static int vid_selectmode (void)
{
	int      i,j;
	uchar    *base;
	ulong    *base2;
	
	lock_io();
	lock_ge();
	
	outp(0x3c4, 0x01);
	outp(0x3c5, 0x21);		// blank the screen

	cirrus_init();

	if (scrnColors == 8) {
		set_table(std_cirrus_vga_table);
		set_table(vga_cirrus_table);
		set_table(sequencer_table);
		set_attr_table(attribute_table);
		setup_dac();
		set_table(gcr_table);
		vid_prepare_crt_8();
		select_clock();
		vid_select_crt_8();
		
		base = (uchar*)scrnBase;
		for (i = 0; i < scrnHeight / 2; i++) {
			for (j = 0; j < scrnWidth / 2; j++) {
				*(base++) = 0xff;
				*(base++) = 0x00;
			}
			for (j = 0; j < scrnWidth / 2; j++) {
				*(base++) = 0x00;
				*(base++) = 0xff;
			}
		}
	}
	else {
		set_table(std_cirrus_vga_table);
		set_table(vga_cirrus_table32);
		set_table(sequencer_table);
		set_attr_table(attribute_table);
		setup_dac32();
		set_table(gcr_table);
		vid_prepare_crt_32();
		select_clock();
		vid_select_crt_32();
		
		base2 = (ulong*)scrnBase;
		for (i = 0; i < scrnHeight / 2; i++) {
			for (j = 0; j < scrnWidth / 2; j++) {
				*(base2++) = 0xffffffff;
				*(base2++) = 0x00000000;
			}
			for (j = 0; j < scrnWidth / 2; j++) {
				*(base2++) = 0x00000000;
				*(base2++) = 0xffffffff;
			}
		}
	}
	
	scrnBufBase = (uchar*)(((long)scrnBase+scrnRowByte*scrnHeight+1023)&0xFFFFFC00);
	
	outp(0x3c4, 0x01);
	outp(0x3c5, 0x01);		//unblank the screen
		
	outp(0x3d4, 0x29);
	outp(0x3d5, 0x84);
	outp(0x217a, 0x34);		// disable hardware cursor
	outp(0x217e, 0x00);

	unlock_ge();
	unlock_io();
}

//--------------------------------------------------------------
// Graphic add-on main entry point
//--------------------------------------------------------------

long control_graphics_card(ulong message,void *buf)
{
	int        i,err;
	ulong      code;
	
	err = B_NO_ERROR;
	switch (message) {
	case B_GET_GRAPHICS_CARD_INFO :
		((graphics_card_info*)buf)->height = scrnHeight;
		((graphics_card_info*)buf)->width = scrnWidth;
		((graphics_card_info*)buf)->bits_per_pixel = scrnColors;
		((graphics_card_info*)buf)->bits = (void*)scrnBase;
		((graphics_card_info*)buf)->bytes_per_row = scrnRowByte;
		((graphics_card_info*)buf)->flags = B_CRT_CONTROL;
		*((long*)&((graphics_card_info*)buf)->rgba_order) = (long)('rgba');
		((graphics_card_info*)buf)->version = 1;
		((graphics_card_info*)buf)->id = 0;
		break;
		
	case B_GET_GRAPHICS_CARD_HOOKS :
		for (i=0;i<B_HOOK_COUNT;i++)
			((graphics_card_hook*)buf)[i] = vga_dispatch[i];
		break;
		
	case B_OPEN_GRAPHICS_CARD :
		scrnBase = ((graphics_card_spec*)buf)->screen_base;
		isa_IO = ((graphics_card_spec*)buf)->io_base;

		if (((graphics_card_spec*)buf)->vendor_id != 0x1013) {
			err = B_ERROR;
			break;
		}
		
		switch (((graphics_card_spec*)buf)->device_id) {
		case 0x00a0:
		case 0x00ac:
			theVGA = cirrus_5430;
			break;
		case 0x00a8:
			theVGA = cirrus_5434;
			break;
		default:
			theVGA = -1;
			break;
		}
		if (theVGA < 0) {
			err = B_ERROR;
			break;
		}

		init_locks();
		
		vid_checkmem();

		break;
		
	case B_CLOSE_GRAPHICS_CARD :
		outp(0x3c4, 0x01);
		outp(0x3c5, 0x21);
		dispose_locks();
		break;
		
	case B_SET_INDEXED_COLOR:
		lock_io();
		
		outp(0x3c6, 0xff);
		inp(0x3c7);
		outp(0x3c8, ((indexed_color*)buf)->index);
		inp(0x3c7);
		
		outp(0x3c9, (((indexed_color*)buf)->color.red) >> 2);
		inp(0x3c7);
		outp(0x3c9, (((indexed_color*)buf)->color.green) >> 2);
		inp(0x3c7);
		outp(0x3c9, (((indexed_color*)buf)->color.blue) >> 2);
		inp(0x3c7);

		unlock_io();
		break;
		
	case B_GET_SCREEN_SPACES:
		((graphics_card_config*)buf)->space = available_spaces;
		break;
		
	case B_CONFIG_GRAPHICS_CARD:
		if ((((graphics_card_config*)buf)->space & available_spaces) == 0) {
			err = B_ERROR;
			break;
		}
		crtPosH = ((graphics_card_config*)buf)->h_position;
		crtSizeH = ((graphics_card_config*)buf)->h_size;
		crtPosV = ((graphics_card_config*)buf)->v_position;
		crtSizeV = ((graphics_card_config*)buf)->v_size;
		if (((graphics_card_config*)buf)->space != scrnResCode) {
			scrnResCode = ((graphics_card_config*)buf)->space;
			scrnResNum = 0;
			code = scrnResCode;
			while (code > 1) {
				scrnResNum++;
				code >>= 1;
			}
			scrnRate = ((graphics_card_config*)buf)->refresh_rate;
			if (scrnRate < vga_min_rates[scrnResNum])
				scrnRate = vga_min_rates[scrnResNum];
			if (scrnRate > vga_max_rates[scrnResNum])
				scrnRate = vga_max_rates[scrnResNum];
			switch (((graphics_card_config*)buf)->space) {
			case B_8_BIT_640x480:
				scrnColors = 8;
				scrnRes = vga640x480;
				scrnWidth = 640;
				scrnHeight = 480;
				scrnRowByte = 640;
				vid_selectmode();
				break;
			case B_8_BIT_800x600:
				scrnColors = 8;
				scrnRes = vga800x600;
				scrnWidth = 800;
				scrnHeight = 600;
				scrnRowByte = 800;
				vid_selectmode();
				break;
			case B_8_BIT_1024x768:
				scrnColors = 8;
				scrnRes = vga1024x768;
				scrnWidth = 1024;
				scrnHeight = 768;
				scrnRowByte = 1024;
				vid_selectmode();
				break;
			case B_32_BIT_640x480:
				scrnColors = 32;
				scrnRes = vga640x480;
				scrnWidth = 640;
				scrnHeight = 480;
				scrnRowByte = 2560;
				vid_selectmode();
				break;
			case B_32_BIT_800x600:
				scrnColors = 32;
				scrnRes = vga800x600;
				scrnWidth = 800;
				scrnHeight = 600;
				scrnRowByte = 3200;
				vid_selectmode();
				break;
			default :
				err = B_ERROR;
			}
		}
		else {
			scrnRate = ((graphics_card_config*)buf)->refresh_rate;
			if (scrnRate < vga_min_rates[scrnResNum])
				scrnRate = vga_min_rates[scrnResNum];
			if (scrnRate > vga_max_rates[scrnResNum])
				scrnRate = vga_max_rates[scrnResNum];
			vid_selectrate();
		}
		break;
	case B_GET_REFRESH_RATES :
		((refresh_rate_info*)buf)->min = vga_min_rates[scrnResNum];
		((refresh_rate_info*)buf)->max = vga_max_rates[scrnResNum];
		((refresh_rate_info*)buf)->current = scrnRate;
		break;
	default:
		err = B_ERROR;
	}
	return err;
}























