/* ++++++++++
	$Source: /net/bally/be/rcs/src/addons/app_server/supervga/supervga.c,v $
	$Revision: 1.6 $
	$Author: pierre $
	$Date: 1996/03/27 23:51:08 $
	Copyright (c) 1995 by Be Incorporated.  All Rights Reserved.
+++++ */

#include <OS.h>
#include "kernel.h"
#include <vga.h>

/* -----
	handly definitions
----- */

#define  xprintf dprintf

/* -----
	private globals
----- */

static sem_id			vidsem = -1;	/* one client at a time... */
static int              scrnRowByte;
static int		        scrnWidth;
static int		        scrnHeight;
static uchar	        *scrnBase;

static volatile uchar   *isa_IO;

#define ISA_ADDRESS(x)  (isa_IO+(x))

//----------------------------------------------------------
// global tables (for all depth)
//----------------------------------------------------------

//----------------------------------------

static ushort	vga_table[] =
{
	0x3c4,	0x00,	0x3c5,	0x00,	// Reset
	0x3c4,	0x00,	0x3c5,	0x03,	// Reset

	0x46e8,	0x10,   0x102,	0x01,   0x46e8,	 0x08,
	0x3c3,  0x01,
	0x3c2,	0x23,

	0x3c4,	0x06,	0x3c5,	0x12,	// cirrus patch	
	0x3c4,	0x07,	0x3c5,	0x11,
	0x3c4,	0x06,	0x3c5,	0x0F,	

	0x3d4,  0x38,   0x3d5,  0x48,   // s3 patch
	0x3d4,  0x39,   0x3d5,  0xa5,
	0x3d4,	0x31,	0x3d5,	0x8c,
	0x3d4,	0x3a,	0x3d5,	0x95,
	0x3d4,	0x58,	0x3d5,	0x11,
	0x3d4,	0x5c,	0x3d5,	0x00,
	0x3d4,	0x55,	0x3d5,	0x01,
	0x3c6,	0x2c,	0x3c7,	0x00,
	0x3c6,	0x2d,	0x3c7,	0x06,
	0x3c6,	0x2d,	0x3c7,	0x05,
	0x3c6,	0x2d,	0x3c7,	0x0a,
	0x3d4,  0x38,   0x3d5,  0xff,
	0x3d4,  0x39,   0x3d5,  0xff,

	0x3c4,	0x01,	0x3c5,	0x21,	// Clocking mode
	0x3c4,	0x02,	0x3c5,	0x0f,	// Enable write plane
	0x3c4,	0x03,	0x3c5,	0x00,	// Char Font Select
	0x3c4,	0x04,	0x3c5,	0x0e,	// Memory Mode
	0x000,	0x00
};

static ushort	vga_table2[] =
{	0x3ce,	0x00,	0x3cf,	0x00,	// Set/Reset
	0x3ce,	0x01,	0x3cf,	0x00,	// Enable Set/Reset
	0x3ce,	0x02,	0x3cf,	0x00,	// Color Compare
	0x3ce,	0x03,	0x3cf,	0x00,	// Raster Operations/Rotate Counter
	0x3ce,	0x04,	0x3cf,	0x00,	// Read Plane Select
	0x3ce,	0x05,	0x3cf,	0x40,	// Graphics Controller
	0x3ce,	0x06,	0x3cf,	0x05,	// Memory Map Mode
	0x3ce,	0x07,	0x3cf,	0x0f,	// Color Don't care
	0x3ce,	0x08,	0x3cf,	0xff,	// Bit Mask

	0x3d4,	0x00,	0x3d5,	0x5f,	// Preset row scan
	0x3d4,	0x01,	0x3d5,	0x4f,	// Preset row scan
	0x3d4,	0x02,	0x3d5,	0x50,	// Preset row scan
	0x3d4,	0x03,	0x3d5,	0x82,	// Preset row scan
	0x3d4,	0x04,	0x3d5,	0x54,	// Preset row scan
	0x3d4,	0x05,	0x3d5,	0x80,	// Preset row scan
	0x3d4,	0x06,	0x3d5,	0x0b,	// Preset row scan
	0x3d4,	0x07,	0x3d5,	0x3e,	// Preset row scan
	0x3d4,	0x08,	0x3d5,	0x00,	// Preset row scan
	0x3d4,	0x09,	0x3d5,	0x40,	// Preset row scan
	0x3d4,	0x0a,	0x3d5,	0x00,	// Cursor start scan line
	0x3d4,	0x0b,	0x3d5,	0x00,	// Cursor end scan line
	0x3d4,	0x0c,	0x3d5,	0x00,	// Start Address High
	0x3d4,	0x0d,	0x3d5,	0x00,	// Start Address Low
	0x3d4,	0x10,	0x3d5,	0xd1,	// Offset
	0x3d4,	0x11,	0x3d5,	0x85,	// Offset
	0x3d4,	0x12,	0x3d5,	0x98,	// Offset
	0x3d4,	0x13,	0x3d5,	0x50,	// Offset
	0x3d4,	0x14,	0x3d5,	0x60,	// Underline location
	0x3d4,	0x15,	0x3d5,	0xa0,	// Underline location
	0x3d4,	0x16,	0x3d5,	0x05,	// Underline location
	0x3d4,	0x17,	0x3d5,	0xab,	// CRTC Mode Control
	0x3d4,	0x18,	0x3d5,	0xff,	// Line Compare

    0x3b8,  0x08,
    0x3ba,  0x74,
    0x3bf,  0x01,
	0x3d8,  0x0a,

	0x00,	0x00			// End-of-table
};

//------------------------------------------------------
// standard input/output stuff
//------------------------------------------------------

static void	outp(long address, uchar value)
{
	*(vuchar *)ISA_ADDRESS(address) = value;
}

//----------------------------------------

static uchar	inp(long address)
{
	return(*(vuchar *)ISA_ADDRESS(address));
}

//----------------------------------------------------------
// card io access protection
//----------------------------------------------------------

static sem_id	io_sem = -1;
static sem_id   ge_sem = -1;
static long		io_lock,ge_lock;

void init_locks()
{
	io_lock = 0L;
	io_sem = create_sem(0,"vga io sem");
	ge_lock = 0L;
	ge_sem = create_sem(0,"vga ge sem");
}

void dispose_locks()
{
	if (ge_sem >= 0) {
		delete_sem(ge_sem);
		delete_sem(io_sem);
	}
}

void lock_io()
{
	int	old;

	old = atomic_add (&io_lock, 1);
	if (old >= 1) {
		acquire_sem(io_sem);	
	}	
}

void unlock_io()
{
	int	old;

	old = atomic_add (&io_lock, -1);
	if (old > 1) {
		release_sem(io_sem);
	}
}	

//--------------------------------------------------------------
// Global In/Out routines
//--------------------------------------------------------------

static uchar attr_val[5] = {0x41,0x00,0x0f,0x00,0x00};

static void	set_attr_table()
{
	uchar	p1,v;
	
	inp(0x3da);
	v = inp(0x3c0);
	
	for (p1=0; p1<5; p1++) {
		inp(0x3da);
		outp(0x3c0, 16+p1);
		outp(0x3c0, attr_val[p1]);
	}

	inp(0x3da);
	outp(0x3c0, v | 0x20);
}

//----------------------------------------

static void	set_table(ushort *ptr)
{
	ushort	p1;
	ushort	p2;

	while(1) {
		p1 = *ptr++;
		p2 = *ptr++;
		if (p1 == 0 && p2 == 0) {
			return;
		}
		outp(p1, p2);
	}
}

static void	setup_dac()
{
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	inp(0x3c6);
	outp(0x3c6, 0x00);
	inp(0x3c8);
	outp(0x3c6, 0xff);
}

/* ----------
	vid_selectmode : set current depth and resolution
----- */

static int vid_selectmode (void)
{
	int      i,j;
	uchar    *base;

	lock_io();

	outp(0x3c4, 0x01);
	outp(0x3c5, 0x21);		// blank the screen

	set_table(vga_table);
	set_attr_table();
	setup_dac();
	set_table(vga_table2);
	
	base = (uchar*)scrnBase;
	for (i = 0; i < scrnHeight / 2; i++) {
		for (j = 0; j < scrnWidth / 2; j++) {
			*(base++) = 0xff;
			*(base++) = 0x00;
		}
		for (j = 0; j < scrnWidth / 2; j++) {
			*(base++) = 0x00;
			*(base++) = 0xff;
		}
	}

	outp(0x3c4, 0x01);
	outp(0x3c5, 0x01);		//unblank the screen

	unlock_io();
}

//--------------------------------------------------------------
// Graphic add-on main entry point
//--------------------------------------------------------------

long control_graphics_card(ulong message,void *buf)
{
	int        i,j,err;
	double     time;
	
	err = B_NO_ERROR;
	switch (message) {
	case B_GET_GRAPHICS_CARD_INFO :
		((graphics_card_info*)buf)->height = scrnHeight;
		((graphics_card_info*)buf)->width = scrnWidth;
		((graphics_card_info*)buf)->bits_per_pixel = 8;
		((graphics_card_info*)buf)->bits = (void*)scrnBase;
		((graphics_card_info*)buf)->bytes_per_row = scrnRowByte;
		((graphics_card_info*)buf)->flags = 0;
		*((long*)&((graphics_card_info*)buf)->rgba_order) = (long)('rgba');
		((graphics_card_info*)buf)->version = 1;
		((graphics_card_info*)buf)->id = 0;
		break;
		
	case B_GET_GRAPHICS_CARD_HOOKS :
		for (i=0;i<B_HOOK_COUNT;i++)
			((graphics_card_hook*)buf)[i] = 0L;
		break;
		
	case B_OPEN_GRAPHICS_CARD :
		scrnBase = ((graphics_card_spec*)buf)->screen_base;
		isa_IO = ((graphics_card_spec*)buf)->io_base;

		init_locks();

		xprintf("Graphic memory available : 256 Ko\n");
		
		time = system_time();
		for (j=0;j<20;j++)
			for (i=0;i<25600;i++)
				((double*)scrnBase)[i] = 0L;
		time = system_time()-time;
		xprintf("Memory card bandwidth : %d Kb/s\n",(long)(4000000000.0/time));
		break;
		
	case B_CLOSE_GRAPHICS_CARD :
		outp(0x3c4, 0x01);
		outp(0x3c5, 0x21);
		dispose_locks();
		break;
		
	case B_SET_INDEXED_COLOR:
		lock_io();
		
		outp(0x3c6, 0xff);
		inp(0x3c7);
		outp(0x3c8, ((indexed_color*)buf)->index);
		inp(0x3c7);
		
		outp(0x3c9, (((indexed_color*)buf)->color.red) >> 2);
		inp(0x3c7);
		outp(0x3c9, (((indexed_color*)buf)->color.green) >> 2);
		inp(0x3c7);
		outp(0x3c9, (((indexed_color*)buf)->color.blue) >> 2);
		inp(0x3c7);

		unlock_io();
		break;
		
	case B_GET_SCREEN_SPACES:
		((graphics_card_config*)buf)->space = B_8_BIT_640x400;
		break;
		
	case B_CONFIG_GRAPHICS_CARD:
		scrnWidth = 640;
		scrnHeight = 409;
		scrnRowByte = 640;
		vid_selectmode();
		break;

	case B_GET_REFRESH_RATES :
		((refresh_rate_info*)buf)->min = 60.0;
		((refresh_rate_info*)buf)->max = 60.0;
		((refresh_rate_info*)buf)->current = 60.0;
		break;
	default:
		err = B_ERROR;
	}
	return err;
}













